chiark / gitweb /
actually bomb out if the control panel does
[jarrg-owen.git] / jpctb
diff --git a/jpctb b/jpctb
index c5bf4aae20fc2034772a8046b68d4a637f103f2b..c4f2b6e6a241035ebc7f891765b2e5269676af50 100755 (executable)
--- a/jpctb
+++ b/jpctb
@@ -32,6 +32,13 @@ fail () {
        echo >&2 "jpctb: $*"
        exit 127
 }
+
+nojre () {
+       fail "couldn't find the right jre: $*
+ perhaps you should make ypp's java symlink (normally yohoho/java)
+ point to your jre, eg to /usr/lib/jvm/java-6-sun"
+}
+
 badusage () {
        fail "bad usage: $*"
 }
@@ -73,58 +80,51 @@ fi
 
 yppdir="${yohoho%/*}"
 
+# this replicates the java-searching logic from yohoho/yohoho:
+if [ -x "$yppdir/java/bin/java" ]; then
+       yppjava="$yppdir/java/bin/java"
+elif [ -x "$JAVA_HOME/bin/java" ]; then
+       yppjava="$JAVA_HOME/bin/java"
+else
+       set +e
+       yppjava=`type -p java 2>&1`
+       set -e
+fi
+
 cat <<END
 jpctb:
    jpctb tree:  "$jpctbdir"
    yohoho:       "$yohoho"
+   ypp dir:      "$yppdir"
+   ypp uses:     "$yppjava"
 END
 
-if [ -x "$yppdir/java/bin/java" ]; then
-       if [ -d "$yppdir/java/jre" ]; then
-               echo "   yohoho/java/bin and yohoho/java/jre exist, good"
-               javadir="$yppdir/java"
-       else
-               absjava=`readlink -f "$yppdir/java/bin/java"`
-               cat <<END
-   yohoho/java/bin exists but yohoho/java/jre does not
-   abs. java:    "$absjava"
-END
-               case "$absjava" in
-               */jre/bin/java)
-                       echo "   found jre directory, good"
-                       javadir="${absjava%/jre/bin/java}"
-                       ;;
-               *)
-                       echo "   java binary not in jre dir as expected, hmm."
-                       ;;
-               esac
-       fi
+if ! [ -x "$yppjava" ]; then
+       nojre "bad java ypp"
 fi
 
-if [ "x$javadir" = x ] && [ x"$JAVA_HOME" != x ] && \
-   [ -x "$JAVA_HOME/bin/java" ]; then
-cat <<END
-   yohoho/java/bin/java nonexistent or unsuitable, trying JAVA_HOME"
-   JAVA_HOME:    "$JAVA_HOME"
-END
-       if [ -d "$JAVA_HOME/jre" ]; then
-               javadir="$JAVA_HOME"
-       else
-               echo "   JAVA_HOME has no jre subdirectory, hmm."
-       fi
-fi
-
-if [ "x$javadir" = x ]; then
-       fail "could not find java runtime system
- please check that $yppdir/java points to your Java installation"
+javadir="${yppjava%/bin/java}"
+if [ -x "$javadir/jre/bin/java" ]; then
+       echo "   java/ points to the jre, good"
+else
+       echo "   java/ has just the executable bin/java, trying readlink"
+       absjava=`readlink -f "$yppjava"`
+       echo "   abs. java:    \"$absjava\""
+       case "$absjava" in
+       */jre/bin/java)
+               echo "   found jre directory, good"
+               javadir="${absjava%/jre/bin/java}"
+               ;;
+       *)
+               nojre "java binary not in jre dir"
+               ;;
+       esac
 fi
 
 case "$javadir" in
-/usr)  fail "javadir is still /usr (and even found /usr/jre!)
- please make $yppdir/java point somewhere more sensible and/or
- reinstall YPP not telling it your java is in /usr.  sorry." ;;
-/*)    ;;
-*)     javadir="$PWD/$javadir" ;;
+''|/|/usr)     nojre "javadir is $javadir (and even found $javadir/jre!)" ;;
+/*)            ;;
+*)             javadir="$PWD/$javadir" ;;
 esac
 
 jtmp="$jpctbdir/tmp"
@@ -144,7 +144,19 @@ END
 
 #---------- run the control panel ----------
 
-"$javadir/bin/java" -jar "$srcjardir/PCTB-ControlPanel.jar"
+set +e
+"$javadir/bin/java" \
+ -Dcom.tedpearson.ypp.market.controlpanel.exitstatus=12 \
+ -jar "$srcjardir/PCTB-ControlPanel.jar"
+rc=$?
+set -e
+
+case $rc in
+0)     echo "launcher dialogue closed, quitting"; exit 0 ;;
+12)    ;;
+*)     echo >&2 "control panel failed with exit status $rc"; exit "$rc" ;;
+esac
+
 
 #---------- create the temporary are and link farm ----------